//+------------------------------------------------------------------+
//|                                         Price MA Cross Alert.mq4 |
//|                              Copyright  2008, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, TradingSytemForex"
#property link "http://www.tradingsystemforex.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 OrangeRed

double CrossUp[];
double CrossDown[];
double prevtime;
double Range,AvgRange;

extern int MAPeriod=100;
extern int MAMethod=0;
extern int MAPrice=0;
extern int MAShift=0;
extern int PriceShift=1;
extern bool SoundAlert=true;

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,CrossUp);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,CrossDown);
//----
   return(0);
}
  
//+------------------------------------------------------------------+
//| Deinitialization                                                 |
//+------------------------------------------------------------------+

int deinit()
{
//---- 

//----
   return(0);
}

//+------------------------------------------------------------------+
//| Iteration                                                        |
//+------------------------------------------------------------------+

int start()
{
   int limit,i,counter;
   int counted_bars=IndicatorCounted();

   if(counted_bars<0)return(-1);
   if(counted_bars>0)counted_bars--;
   
   limit=Bars-counted_bars;
   
   for(i=0;i<=limit;i++)
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for(counter=i;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      
      double MA=iMA(Symbol(),0,MAPeriod,0,MAMethod,MAPrice,i+MAShift); 
      CrossUp[i]  =EMPTY_VALUE;
      CrossDown[i]=EMPTY_VALUE;
      if(Open[i+PriceShift]<MA&&Close[i+PriceShift]>MA)
      {
         CrossUp[i]=Low[i]-Range*0.5;
       }
       
      if(Open[i+PriceShift]>MA&&Close[i+PriceShift]<MA)
      {
         CrossDown[i]=High[i]+Range*0.5;
      }
   }
   if((CrossUp[0]>2000) && (CrossDown[0]>2000)){prevtime=0;}
   if((CrossUp[0]==Low[0]-Range*0.5) && (prevtime!=Time[0]) && SoundAlert)
   {
      prevtime=Time[0];
      Alert(Symbol()," Price MA Cross Alert Up @  Hour ",Hour(),"  Minute ",Minute());
      PlaySound ("alert.wav");
   } 
   if((CrossDown[0]==High[0]+Range*0.5) && (prevtime!=Time[0]) && SoundAlert)
   {
      prevtime=Time[0];
      Alert(Symbol()," Price MA Cross Alert Down @  Hour ",Hour(),"  Minute ",Minute());
      PlaySound ("alert.wav");
   }
   return(0);
 }

